package com.zcloud.modules.kangzai.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zcloud.common.utils.PageUtils;
import com.zcloud.modules.kangzai.dao.BusRiverSectionsDao;
import com.zcloud.modules.kangzai.entity.BusRiverSectionsEntity;
import com.zcloud.modules.kangzai.service.BusRiverSectionsService;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import java.util.List;
import java.util.Map;

/**
 * @Author fangjiakai
 * @Desc 河流县区段信息表(BusRiverSections)表服务实现类
 * @Date 2025-06-09 09:44:25
 */
@Service("busRiverSectionsService")
public class BusRiverSectionsServiceImpl extends ServiceImpl<BusRiverSectionsDao, BusRiverSectionsEntity> implements BusRiverSectionsService {

    @Override
    public BusRiverSectionsEntity queryByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusRiverSectionsEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectOne(queryWrapper);
    }

    @Override
    public List<BusRiverSectionsEntity> queryListByFlexibleParams(String paramName, Object paramValue) {
        QueryWrapper<BusRiverSectionsEntity> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq(paramName, paramValue); // 根据传入的参数名和参数值动态构建查询条件

        return baseMapper.selectList(queryWrapper);
    }

    @Override
    public PageUtils listPage(Map<String, Object> params) {
        Page<Map<String, Object>> page = new Page<>(Integer.parseInt(params.get("curPage").toString()), Integer.parseInt(params.get("limit").toString()));
        params.put("isDelete", 0);
        IPage<BusRiverSectionsEntity> ipage = baseMapper.listPage(page, params);
        return new PageUtils(ipage);
    }


    @Override
    public void delete(String riverSectionsId, String userId) {
        UpdateWrapper<BusRiverSectionsEntity> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("river_sections_id", riverSectionsId);

        BusRiverSectionsEntity busRiverSections = new BusRiverSectionsEntity();
        busRiverSections.setIsDelete(1);

        this.update(busRiverSections, updateWrapper);
    }
}
